/* Generated by GIWS (version 1.0.6) */
/*

Copyright 2007-2008 INRIA

Author : Sylvestre Ledru & others

This software is a computer program whose purpose is to hide the complexity
of accessing Java objects/methods from C++ code.

This software is governed by the CeCILL-B license under French law and
abiding by the rules of distribution of free software.  You can  use, 
modify and/ or redistribute the software under the terms of the CeCILL-B
license as circulated by CEA, CNRS and INRIA at the following URL
"http://www.cecill.info". 

As a counterpart to the access to the source code and  rights to copy,
modify and redistribute granted by the license, users are provided only
with a limited warranty  and the software's author,  the holder of the
economic rights,  and the successive licensors  have only  limited
liability. 

In this respect, the user's attention is drawn to the risks associated
with loading,  using,  modifying and/or developing or reproducing the
software by the user in light of its specific status of free software,
that may mean  that it is complicated to manipulate,  and  that  also
therefore means  that it is reserved for developers  and  experienced
professionals having in-depth computer knowledge. Users are therefore
encouraged to load and test the software's suitability as regards their
requirements in conditions enabling the security of their systems and/or 
data to be ensured and,  more generally, to use and operate it in the 
same conditions as regards security. 

The fact that you are presently reading this means that you have had
knowledge of the CeCILL-B license and that you accept its terms.
*/


#ifndef __ORG_SCILAB_MODULES_GRAPHIC_EXPORT_JOGLCONSTANT__
#define __ORG_SCILAB_MODULES_GRAPHIC_EXPORT_JOGLCONSTANT__
#include <iostream>
#include <string>
#include <string.h>
#include <stdlib.h>
#include <jni.h>

#include "GiwsException.hxx"

namespace org_scilab_modules_graphic_export {

class JOGLConstant {
private:
JavaVM * jvm;
jobject instance;

jclass instanceClass; // cache class
jmethodID jintget_GL_RGBAID; // cache method id
jmethodID jintget_GL_RGBID; // cache method id
jmethodID jintget_GL_CURRENT_RASTER_POSITION_VALIDID; // cache method id
jmethodID jintget_GL_CURRENT_RASTER_POSITIONID; // cache method id
jmethodID jintget_GL_CURRENT_RASTER_COLORID; // cache method id
jmethodID jintget_GL_SRC_ALPHAID; // cache method id
jmethodID jintget_GL_ONE_MINUS_SRC_ALPHAID; // cache method id
jmethodID jintget_GL_ONEID; // cache method id
jmethodID jintget_GL_ZEROID; // cache method id
jmethodID jintget_GL_COLOR_INDEXID; // cache method id
jmethodID jintget_GL_POINT_TOKENID; // cache method id
jmethodID jintget_GL_LINE_TOKENID; // cache method id
jmethodID jintget_GL_LINE_RESET_TOKENID; // cache method id
jmethodID jintget_GL_POLYGON_TOKENID; // cache method id
jmethodID jintget_GL_BITMAP_TOKENID; // cache method id
jmethodID jintget_GL_DRAW_PIXEL_TOKENID; // cache method id
jmethodID jintget_GL_COPY_PIXEL_TOKENID; // cache method id
jmethodID jintget_GL_PASS_THROUGH_TOKENID; // cache method id
jmethodID jintget_GL_FEEDBACKID; // cache method id
jmethodID jintget_GL_COLOR_CLEAR_VALUEID; // cache method id
jmethodID jintget_GL_INDEX_CLEAR_VALUEID; // cache method id
jmethodID jintget_GL_RENDERID; // cache method id
jmethodID jintget_GL_VIEWPORTID; // cache method id
jmethodID jintget_GL_BLENDID; // cache method id
jmethodID jintget_GL_BLEND_SRCID; // cache method id
jmethodID jintget_GL_BLEND_DSTID; // cache method id
jmethodID jintget_GL_3D_COLORID; // cache method id
jmethodID jintget_GL_FLOATID; // cache method id
jmethodID jintget_GL_UNSIGNED_BYTEID; // cache method id
jmethodID jintget_GL_POINTSID; // cache method id
jmethodID jintget_GL_POLYGON_OFFSET_FACTORID; // cache method id
jmethodID jintget_GL_POLYGON_OFFSET_UNITSID; // cache method id
jmethodID jintget_GL_LINE_STIPPLE_PATTERNID; // cache method id
jmethodID jintget_GL_LINE_STIPPLE_REPEATID; // cache method id


/**
* Get the environment matching to the current thread.
*/
JNIEnv * getCurrentEnv();

public:
// Constructor
/**
* Create a wrapping of the object from a JNIEnv.
* It will call the default constructor
* @param JEnv_ the Java Env
*/
JOGLConstant(JavaVM * jvm_);
/**
* Create a wrapping of an already existing object from a JNIEnv.
* The object must have already been instantiated
* @param JEnv_ the Java Env
* @param JObj the object
*/
JOGLConstant(JavaVM * jvm_, jobject JObj);

// Destructor
~JOGLConstant();

// Generic method
// Synchronization methods
/**
* Enter monitor associated with the object.
* Equivalent of creating a "synchronized(obj)" scope in Java.
*/
void synchronize();

/**
* Exit monitor associated with the object.
* Equivalent of ending a "synchronized(obj)" scope.
*/
void endSynchronize();

// Methods
static int get_GL_RGBA(JavaVM * jvm_);

static int get_GL_RGB(JavaVM * jvm_);

static int get_GL_CURRENT_RASTER_POSITION_VALID(JavaVM * jvm_);

static int get_GL_CURRENT_RASTER_POSITION(JavaVM * jvm_);

static int get_GL_CURRENT_RASTER_COLOR(JavaVM * jvm_);

static int get_GL_SRC_ALPHA(JavaVM * jvm_);

static int get_GL_ONE_MINUS_SRC_ALPHA(JavaVM * jvm_);

static int get_GL_ONE(JavaVM * jvm_);

static int get_GL_ZERO(JavaVM * jvm_);

static int get_GL_COLOR_INDEX(JavaVM * jvm_);

static int get_GL_POINT_TOKEN(JavaVM * jvm_);

static int get_GL_LINE_TOKEN(JavaVM * jvm_);

static int get_GL_LINE_RESET_TOKEN(JavaVM * jvm_);

static int get_GL_POLYGON_TOKEN(JavaVM * jvm_);

static int get_GL_BITMAP_TOKEN(JavaVM * jvm_);

static int get_GL_DRAW_PIXEL_TOKEN(JavaVM * jvm_);

static int get_GL_COPY_PIXEL_TOKEN(JavaVM * jvm_);

static int get_GL_PASS_THROUGH_TOKEN(JavaVM * jvm_);

static int get_GL_FEEDBACK(JavaVM * jvm_);

static int get_GL_COLOR_CLEAR_VALUE(JavaVM * jvm_);

static int get_GL_INDEX_CLEAR_VALUE(JavaVM * jvm_);

static int get_GL_RENDER(JavaVM * jvm_);

static int get_GL_VIEWPORT(JavaVM * jvm_);

static int get_GL_BLEND(JavaVM * jvm_);

static int get_GL_BLEND_SRC(JavaVM * jvm_);

static int get_GL_BLEND_DST(JavaVM * jvm_);

static int get_GL_3D_COLOR(JavaVM * jvm_);

static int get_GL_FLOAT(JavaVM * jvm_);

static int get_GL_UNSIGNED_BYTE(JavaVM * jvm_);

static int get_GL_POINTS(JavaVM * jvm_);

static int get_GL_POLYGON_OFFSET_FACTOR(JavaVM * jvm_);

static int get_GL_POLYGON_OFFSET_UNITS(JavaVM * jvm_);

static int get_GL_LINE_STIPPLE_PATTERN(JavaVM * jvm_);

static int get_GL_LINE_STIPPLE_REPEAT(JavaVM * jvm_);


                        /**
                        * Get class name to use for static methods
                        * @return class name to use for static methods
                        */
                        
                static const std::string className()
                {
                return "org/scilab/modules/graphic_export/JOGLConstant";
                }
                
};


}
#endif
